// Copyright (C) 2013 - 2016 - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt


x = linspace(0,%pi,10)';
y = sin(x);
p = polyfit(x,y,3);
expected=[
   2.111148559743582870D-17  
  -4.038880514217270679D-01  
   1.268851735219194143D+00  
  -2.342223135071501081D-02  
]';
atol=1.e-15;
assert_checkalmostequal(p,expected,[],atol);
//
// Source: http://www.census.gov/population/censusdata/table-4.pdf
// USA population : Population: 1790 to 1990
// Caution : the urban definition changes in 1950
cdate=(1790:10:1990)';
pop=[
    3.929214   
    5.308483   
    7.239881   
    9.638453   
    12.860702  
    17.063353  
    23.191876  
    31.443321  
    38.558371  
    50.189209  
    62.979766  
    76.212168  
    92.228496  
    106.02154  
    123.20262  
    132.16457  
    151.3258   
    179.32317  
    203.30203  
    226.5422   
    248.70987  
 ];
// Calculate fit parameters
[p,S,mu] = polyfit(cdate,pop,2);
// Check the fit
pexact=[25.049403    75.414052    61.926049];
assert_checkalmostequal(p,pexact);
// Evaluate the fit
pop_fit = polyval(p,cdate,S,mu);
assert_checkalmostequal(pop_fit,pop,[],10);

// http://forge.scilab.org/index.php/p/stixbox/issues/1146
// Experimental data (noisy Gaussian tail)
x = [ 1000; 1040; 1080; 1120];
d = [ 2.25E-03; 1.67E-02; 9.79E-02; 3.75E-01 ];
y = log10(d);
[p,S,mu] = polyfit(x,y,2);
expected=[-0.1197022    0.9596752  -1.3752951];
assert_checkalmostequal(p,expected,[],1.e-7);

// http://forge.scilab.org/index.php/p/stixbox/issues/1618/
// Difficult sample : standardizing is necessary
x=[-1e15 1.e6 1e15]; 
y=[-12. 0 12.]; 
[p,S,mu]=polyfit(x,y,2);
exact=[1.20000056D-08    1.20000000D+01  -8.00000292D-09];
assert_checkalmostequal(p,exact,1.e-7);
y2=polyval(p,x,S,mu);
assert_checkalmostequal(y2,y,[],1.e-7);
